mirror of https://lore.kernel.org/lkml/
 help / color / mirror / Atom feed
From: Adrian Hunter <adrian.hunter@intel.com>
To: Arnaldo Carvalho de Melo <acme@kernel.org>
Cc: Jiri Olsa <jolsa@redhat.com>, Ian Rogers <irogers@google.com>,
	Alexey Bayduraev <alexey.v.bayduraev@linux.intel.com>,
	Namhyung Kim <namhyung@kernel.org>, Leo Yan <leo.yan@linaro.org>,
	linux-kernel@vger.kernel.org
Subject: [PATCH V1 01/23] perf intel-pt: Add a test for system-wide side band
Date: Thu,  5 May 2022 19:56:17 +0300	[thread overview]
Message-ID: <20220505165639.361733-2-adrian.hunter@intel.com> (raw)
In-Reply-To: <20220505165639.361733-1-adrian.hunter@intel.com>

Add a test for system-wide side band even when tracing selected CPUs.

Signed-off-by: Adrian Hunter <adrian.hunter@intel.com>
---
 tools/perf/tests/shell/test_intel_pt.sh | 71 +++++++++++++++++++++++++
 1 file changed, 71 insertions(+)
 create mode 100755 tools/perf/tests/shell/test_intel_pt.sh

diff --git a/tools/perf/tests/shell/test_intel_pt.sh b/tools/perf/tests/shell/test_intel_pt.sh
new file mode 100755
index 000000000000..a3298643884d
--- /dev/null
+++ b/tools/perf/tests/shell/test_intel_pt.sh
@@ -0,0 +1,71 @@
+#!/bin/sh
+# Miscellaneous Intel PT testing
+# SPDX-License-Identifier: GPL-2.0
+
+set -e
+
+# Skip if no Intel PT
+perf list | grep -q 'intel_pt//' || exit 2
+
+skip_cnt=0
+ok_cnt=0
+err_cnt=0
+
+tmpfile=`mktemp`
+perfdatafile=`mktemp`
+
+can_cpu_wide()
+{
+	perf record -o ${tmpfile} -B -N --no-bpf-event -e dummy:u -C $1 true 2>&1 >/dev/null || return 2
+	return 0
+}
+
+test_system_wide_side_band()
+{
+	# Need CPU 0 and CPU 1
+	can_cpu_wide 0 || return $?
+	can_cpu_wide 1 || return $?
+
+	# Record on CPU 0 a task running on CPU 1
+	perf record -B -N --no-bpf-event -o ${perfdatafile} -e intel_pt//u -C 0 -- taskset --cpu-list 1 uname
+
+	# Should get MMAP events from CPU 1 because they can be needed to decode
+	mmap_cnt=`perf script -i ${perfdatafile} --no-itrace --show-mmap-events -C 1 2>/dev/null | grep MMAP | wc -l`
+
+	if [ ${mmap_cnt} -gt 0 ] ; then
+		return 0
+	fi
+
+	echo "Failed to record MMAP events on CPU 1 when tracing CPU 0"
+	return 1
+}
+
+count_result()
+{
+	if [ $1 -eq 2 ] ; then
+		skip_cnt=`expr ${skip_cnt} \+ 1`
+		return
+	fi
+	if [ $1 -eq 0 ] ; then
+		ok_cnt=`expr ${ok_cnt} \+ 1`
+		return
+	fi
+	err_cnt=`expr ${err_cnt} \+ 1`
+}
+
+test_system_wide_side_band
+
+count_result $?
+
+rm -f ${tmpfile}
+rm -f ${perfdatafile}
+
+if [ ${err_cnt} -gt 0 ] ; then
+	exit 1
+fi
+
+if [ ${ok_cnt} -gt 0 ] ; then
+	exit 0
+fi
+
+exit 2
-- 
2.25.1


  reply	other threads:[~2022-05-05 16:56 UTC|newest]

Thread overview: 52+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2022-05-05 16:56 [PATCH V1 00/23] perf intel-pt: Better support for perf record --cpu Adrian Hunter
2022-05-05 16:56 ` Adrian Hunter [this message]
2022-05-05 22:37   ` [PATCH V1 01/23] perf intel-pt: Add a test for system-wide side band Ian Rogers
2022-05-05 16:56 ` [PATCH V1 02/23] libperf evsel: Add perf_evsel__enable_thread() Adrian Hunter
2022-05-05 22:48   ` Ian Rogers
2022-05-06  7:18     ` Adrian Hunter
2022-05-05 16:56 ` [PATCH V1 03/23] perf evlist: Use libperf functions in evlist__enable_event_idx() Adrian Hunter
2022-05-05 22:58   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 04/23] perf auxtrace: Move evlist__enable_event_idx() to auxtrace.c Adrian Hunter
2022-05-05 23:06   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 05/23] perf auxtrace: Do not mix up mmap idx Adrian Hunter
2022-05-05 23:08   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 06/23] libperf evlist: Remove ->idx() per_cpu parameter Adrian Hunter
2022-05-05 23:08   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 07/23] libperf evlist: Move ->idx() into mmap_per_evsel() Adrian Hunter
2022-05-05 23:09   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 08/23] libperf evlist: Add evsel as a parameter to ->idx() Adrian Hunter
2022-05-05 23:27   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 09/23] perf auxtrace: Record whether an auxtrace mmap is needed Adrian Hunter
2022-05-05 23:28   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 10/23] perf auxtrace: Add mmap_needed to auxtrace_mmap_params Adrian Hunter
2022-05-05 23:40   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 11/23] perf auxtrace: Remove auxtrace_mmap_params__set_idx() per_cpu parameter Adrian Hunter
2022-05-05 22:13   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 12/23] perf evlist: Factor out evlist__dummy_event() Adrian Hunter
2022-05-05 23:42   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 13/23] perf evlist: Add evlist__add_system_wide_dummy() Adrian Hunter
2022-05-05 23:56   ` Ian Rogers
2022-05-06  8:14     ` Adrian Hunter
2022-05-06  8:34       ` Ian Rogers
2022-05-06  9:27         ` Adrian Hunter
2022-05-05 16:56 ` [PATCH V1 14/23] perf record: Use evlist__add_system_wide_dummy() in record__config_text_poke() Adrian Hunter
2022-05-05 23:57   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 15/23] perf intel-pt: Use evlist__add_system_wide_dummy() for switch tracking Adrian Hunter
2022-05-05 23:58   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 16/23] perf intel-pt: Track sideband system-wide when needed Adrian Hunter
2022-05-06  0:01   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 17/23] perf tools: Allow all_cpus to be a superset of user_requested_cpus Adrian Hunter
2022-05-05 16:56 ` [PATCH V1 18/23] libperf evlist: Allow mixing per-thread and per-cpu mmaps Adrian Hunter
2022-05-06  0:09   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 19/23] libperf evlist: Check nr_mmaps is correct Adrian Hunter
2022-05-06  0:13   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 20/23] perf stat: Add requires_cpu flag for uncore Adrian Hunter
2022-05-06  0:50   ` Ian Rogers
2022-05-06  0:52     ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 21/23] libperf evsel: Add comments for booleans Adrian Hunter
2022-05-06  0:55   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 22/23] perf tools: Allow system-wide events to keep their own CPUs Adrian Hunter
2022-05-06  1:00   ` Ian Rogers
2022-05-05 16:56 ` [PATCH V1 23/23] perf tools: Allow system-wide events to keep their own threads Adrian Hunter
2022-05-06  0:51   ` Ian Rogers
2022-05-06  1:06 ` [PATCH V1 00/23] perf intel-pt: Better support for perf record --cpu Ian Rogers

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20220505165639.361733-2-adrian.hunter@intel.com \
    --to=adrian.hunter@intel.com \
    --cc=acme@kernel.org \
    --cc=alexey.v.bayduraev@linux.intel.com \
    --cc=irogers@google.com \
    --cc=jolsa@redhat.com \
    --cc=leo.yan@linaro.org \
    --cc=linux-kernel@vger.kernel.org \
    --cc=namhyung@kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox

all inboxes | Powered by JetHome®